<template>
  <div>
    <li>
      <a
        class="kioskbutton"
        data-control="PopupTrigger"
        @click="openSurvey()">
        <img src="/images/kiosk-button2-survey.png">
      </a>
    </li>
    <survey-modal ref="surveyModal">
      <div
        v-if="!completedSurvey"
        id="overlay"
        slot="survey">
        <section
          id="surveywindow"
          style="display: block;"
          class="surveywindow modalwindow"
          data-control="Popup">
          <div
            style="padding: 5.0rem 3.0rem 0 12.0rem;"
            class="windowcontent clearfix">
            <p>Survey</p>
            <div v-show="finished === false">
              <questions
                v-if="selectedQuestion"
                :account="account"
                :question="selectedQuestion"
                :other="selectedQuestion.answer"/>

              <div class="navButtons clearfix">
                <div
                  v-if="account.survey_position != 1"
                  class="popupbuttoncontainer backbutton">
                  <div class="popupbtn buttonleft"/>
                  <div
                    class="popupbtn buttonmiddle"
                    @click="previousQuestion()">Back</div>
                  <div class="popupbtn buttonright"/>
                  <div class="clear"/>
                </div>
                <div
                  v-if="account.survey_position != questions.length"
                  class="popupbuttoncontainer surveybutton">
                  <div class="popupbtn buttonleft"/>
                  <div
                    class="popupbtn buttonmiddle"
                    @click="nextQuestion()">Next</div>
                  <div class="popupbtn buttonright"/>
                  <div class="clear"/>
                </div>
                <div
                  v-else
                  class="popupbuttoncontainer surveybutton">
                  <div class="popupbtn buttonleft"/>
                  <div
                    class="popupbtn buttonmiddle"
                    @click="finish()">Done</div>
                  <div class="popupbtn buttonright"/>
                  <div class="clear"/>
                </div>
              </div>
              <div
                class="surveypagecontainer"
                style="">
                <div class="pagelabel">Question</div>
                <div
                  v-for="question in questions"
                  :key="question.id"
                  :class="{surveypageactive:account.survey_position === question.order}"
                  class="circleBase surveypage">{{ question.order }}
                </div>
              </div>
            </div>
            <div v-show="finished === true">
              <div class="wrapper">
                <p>Thanks for taking our survey!</p>
                <p class="surveydescription">$1.00 has been deposited in your account!</p>
              </div>
            </div>

            <div class="clear"/>

            <div class="clear"/>
          </div>
          <a
            class="close closebutton maskfadeout"
            data-dismiss="modal"
            @click="$refs.surveyModal.Close()"><img src="/images/closebutton.png"></a>
        </section>
      </div>
      <div
        v-else
        id="overlay"
        slot="survey">
        <section
          id="surveywindow"
          style="display: block;"
          class="surveywindow modalwindow"
          data-control="Popup">
          <div
            style="padding: 5.0rem 3.0rem 0 12.0rem;"
            class="windowcontent clearfix">Thanks for completing your Survey!
            <div class="popupbuttoncontainer signup">
              <div class="popupbtn buttonleft"/>
              <div
                class="popupbtn buttonmiddle"
                @click="$refs.surveyModal.Close()">Close
              </div>
              <div class="popupbtn buttonright"/>
              <div class="clear"/>
            </div>
          </div>
          <a
            class="close closebutton maskfadeout"
            data-dismiss="modal"
            @click="$refs.surveyModal.Close()"><img src="/images/closebutton.png"></a>
        </section>
      </div>
    </survey-modal>
  </div>
</template>

<script>
import SurveyModal from "../../../shared/views/ShopModal.vue";
import Questions from "../../kiosk/components/Question.vue";

export default {
  components: {
    SurveyModal,
    Questions
  },
  props: {
    completedSurvey: Boolean,
    account:Object
  },
  data(){
    return {
      questions:Array,
      selectedQuestion:Object,
      finished:false
    };
  },
  methods:{
    getQuestions(){
      app.api.Get("survey/byAccountId/" + this.account.accountId)
        .then( Response => {
          this.questions = Response;
          this.updateSurveyPosition();
          this.$refs.surveyModal.Open();
        })
        .catch( x => app.Message( x.error, "error" ) );
    },
    openSurvey(){
      this.getQuestions();
    },
    nextQuestion(){
      if(this.validate()){
        this.account.survey_position += 1;
        this.updateSurveyPosition();
        app.api.Put("accounts/" + this.account.id, this.account)
          .then( Response => {
          })
          .catch( x => app.Message( x.error, "error" ) );
      }
    },
    previousQuestion(){
      this.account.survey_position -= 1;
      this.updateSurveyPosition();
        app.api.Put("accounts/" + this.account.id, this.account)
          .then( Response => {
          })
          .catch( x => app.Message( x.error, "error" ) );

    },
    updateSurveyPosition(){
      this.selectedQuestion = {};
      this.selectedQuestion = this.questions.filter(question => question.order == this.account.survey_position)[0];
    },
    validate(){
      if(this.selectedQuestion.required === true){
        if(!this.selectedQuestion.answer){
          app.Message( "Please fill out the question", "error" );
          return false;
        }
      }
      return true;
    },
    finish(){
      if(this.validate()){
        this.finished = true;
        this.selectedQuestion = {};
        this.questions = [];
        let self = this;
          setTimeout( function(){
          self.$refs.surveyModal.Close();
          self.finished = false;
        }, 3000);
      }
    }
  }
};
</script>

<style>


</style>

